#include <bits/stdc++.h>

using ll = long long;
using namespace std;

void solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}

vector<vector<int>> g;

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n);
    vector<int> used(n);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    set<pair<int, int>> d;
    for (int i = 0; i < k; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        d.insert({v, u});
    }
    while (!d.empty()) {
        int v = d.rbegin()->first, u = d.rbegin()->second;
        d.erase(*d.rbegin());
        if (used[u] == 1) {
            continue;
        }
        if (v == -1) {
            continue;
        }
        used[u] = 1;
        for (auto to: g[u]) {
            if (used[to] == 0) {
                d.insert({v - 1, to});
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (used[i] == 1) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << "\n";
    for (auto x: ans) {
        cout << x << " ";
    }
}